DECLARE @userId uniqueidentifier, @unitId uniqueidentifier, @statusId uniqueidentifier, @queueName nvarchar(50), @operatorId uniqueidentifier, @queueId uniqueidentifier, @existingRelation uniqueidentifier;

SET @queueName = 'Retail Onboarding';

SET @userId = (select systemuserid from EbsMetadata.SystemUser where UserName = 'host');
SET @unitId = (select BusinessUnitId from EbsMetadata.BusinessUnit where Name = 'root');
SET @statusId = (select entitystatusid from EbsMetadata.EntityStatus where Name = 'active');

SET @operatorId = (select o.FTOS_DFP_Operatorid from ebs.FTOS_DFP_Operator o
join EbsMetadata.SystemUser s on o.OperatorUserId = s.systemuserid
where s.UserName = 'host');
IF @operatorId is null
	insert into ebs.FTOS_DFP_Operator (FTOS_DFP_Operatorid, Name, OperatorUserId, CreatedOn, ModifiedOn, UserId, CreatedByUserId, ModifiedByUserId, BusinessUnitId, EntityStatusId) values (NEWID(), 'operator', @userId, GETDATE(), GETDATE(), @userId, @userId, @userId, @unitId, @statusId);
	SET @operatorId = (select o.FTOS_DFP_Operatorid from ebs.FTOS_DFP_Operator o
	join EbsMetadata.SystemUser s on o.OperatorUserId = s.systemuserid
	where s.UserName = 'host');

SET @queueId = (select FTOS_DFP_Queueid from ebs.FTOS_DFP_Queue where name = @queueName)
IF @queueId is null
	insert into ebs.FTOS_DFP_Queue (FTOS_DFP_Queueid, Name, CreatedOn, ModifiedOn, UserId, CreatedByUserId, ModifiedByUserId, BusinessUnitId, EntityStatusId) values (NEWID(), @queueName, GETDATE(), GETDATE(), @userId, @userId, @userId, @unitId, @statusId);
	SET @queueId = (select FTOS_DFP_Queueid from ebs.FTOS_DFP_Queue where name = @queueName)

SET @existingRelation = (select FTOS_DFP_Operator_x_FTOS_DFP_Queueid from ebs.FTOS_DFP_Operator_x_FTOS_DFP_Queue where FTOS_DFP_Operatorid=@operatorId and FTOS_DFP_Queueid=@queueId)
if @existingRelation is null
	insert into ebs.FTOS_DFP_Operator_x_FTOS_DFP_Queue (FTOS_DFP_Operator_x_FTOS_DFP_Queueid, FTOS_DFP_Operatorid, FTOS_DFP_Queueid) values (NEWID(), @operatorId, @queueId)
